import { DeepClient } from '@deep-foundation/deeplinks/imports/client';
import { Messaging } from '@firebase/messaging';
/**
 * Registers device
 *
 * @remarks
 * This function also handle onMessage event
 *
 * @example
```ts
await registerDevice({
  deep,
  deviceLinkId,
  firebaseMessaging,
})
```
 */
export declare function registerDevice({ deep, deviceLinkId, firebaseMessaging, callback, }: RegisterDeviceParam): Promise<void>;
export interface RegisterDeviceParam {
    /**
     * Deep Client
     */
    deep: DeepClient;
    /**
     * Device link id
     */
    deviceLinkId: number;
    /**
     * Firebase Messaging
     */
    firebaseMessaging: Messaging;
    /**
     * Callback to be called when device registration token is received
     */
    callback: ({ deviceRegistrationToken, }: {
        deviceRegistrationToken: string;
    }) => void;
}
